ods _all_ close;
ods noptitle;
    
** 1: Start with a working SAS program;
ods html file='c:\temp\report.html'
    style=sasweb;
  proc print data=sashelp.class(obs=5);
    title "SASHELP.CLASS: Obs=5";
  run;
     
  ods select attributes variables sortedby;
  proc contents data=sashelp.class;
    title "Documentation for: SASHELP.CLASS";
  run;
ods html close;
   
** 2: Introduce macro variables;
%let lib=sashelp;
%let data = class;
%let numobs = 5;
   
ods html file='c:\temp\report.html'
    style=sasweb;
  proc print data=&lib..&data(obs=&numobs);
    title "&lib..&data: Obs=&numobs";
  run;
     
  ods select attributes variables sortedby;
  proc contents data=&lib..&data;
    title "Documentation for: &lib..&data";
  run;
ods html close;

** 3a) Refine the code by using macro functions;
%let lib=sashelp;
%let data = class;
%let numobs = 5;
    
ods html file='c:\temp\report.html'
    style=sasweb;
  proc print data=&lib..&data(obs=&numobs);
    title "%upcase(&lib..&data): Obs=&numobs";
  run;
     
  ods select attributes variables sortedby;
  proc contents data=&lib..&data;
    title "Documentation for: %sysfunc(propcase(&lib..&data))";
  run;
ods html close;

** 3b) use single quotes with PROC PRINT step;
ods listing;
ods html file='c:\temp\report_bad.html'
    style=sasweb;
  proc print data=&lib..&data(obs=&numobs);
    title '%upcase(&lib..&data): Obs=&numobs';
  run;
     
  ods select attributes variables sortedby;
  proc contents data=&lib..&data;
    title "Documentation for: %sysfunc(propcase(&lib..&data))";
  run;
ods html close;

**4) Test the code with other values;
%let lib=sashelp;
%let data = shoes;
%let numobs = 15;
   
ods html file='c:\temp\report.html'
    style=sasweb;
  proc print data=&lib..&data(obs=&numobs);
    title "%upcase(&lib..&data): Obs=&numobs";
  run;
     
  ods select attributes variables sortedby;
  proc contents data=&lib..&data;
    title "Documentation for: %sysfunc(propcase(&lib..&data))";
  run;
ods html close;
  
options nomprint nosymbolgen nomlogic;


**5) Example of indirect reference;
%let muppet1 = Kermit;
%let muppet2 = Elmo;
%put Muppet1 is &muppet1 and Muppet2 is &muppet2;
 
%let num=1;
%put I like Muppet&num who is &&muppet&num;
 
%let num=2;
%put I also like Muppet&num who is &&muppet&num;

