** Make a data set for each age or sex value using a more generic approach;
options mcompilenote=all;
%macro sep (data=, var=);
   proc sort data=&data(keep=&var) out=values nodupkey;
      by &var;
   run;
      
   data _null_;
      set values end=last;
      call symputx('mv'||left(_n_),&var);
      if last then call symputx('count',_n_);
   run;
       
   data
   %do i=1 %to &count;
      dsn_&&mv&i
   %end;
   ;
      set &data;
      select(&var);
   %if &var = age %then %do;
     %do i=1 %to &count;
        when(&&mv&i) output dsn_&&mv&i;
     %end;
   %end;
   %else %do;
     %do i=1 %to &count;
        when("&&mv&i") output dsn_&&mv&i;
     %end;
   %end;

      otherwise;
      end;
   run;
%mend sep;

options mprint;

%sep(data=sashelp.class, var=age)
%sep(data=sashelp.class, var=sex)
